clear
clear global

global paramlist params param_switch
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Run model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

setpathdynare4

%dynare nonlinear     % model with no investment adjustment costs
nonlinear_saved

%extract relevant objects from solution 
lgx_ = M_.exo_names;
lgy_ = M_.endo_names;
dr_ = oo_.dr;
ys_ = oo_.dr.ys;

paramfile_assembled
def_parm_assembled

paramlist = char('c1gamrs',...
                 'c1gamdpc',...
                 'c1gamgdpgap');
params = [c1gamrs
          c1gamdpc
          c1gamgdpgap];

param_switch = 1;
options = optimset('HessUpdate','bfgs','display','iter','MaxIter',10000,'MaxFunEvals',1e10,'TolFun',10e-3,'TolX',1e-4);
lowerbound = [-0.000001
              -0.000001
              -0.000001];

upperbound = [10
              10
              10];

[thetaunc,fval,exitflag] = ...
          fminsearch('welfeval',params,options,paramlist,lowerbound,upperbound);
params = thetaunc;

[thetaunc,fval,exitflag] = ...
    fminunc('welfeval',params,options,paramlist,lowerbound,upperbound);


%annealing
%loss = @(x0)updatemod_anneal(x0);
%option = anneal();
%option.Verbosity = 2;
%[thetaunc, fval] = anneal(loss,params);
%exitflag = 0;

%%%% Make figure to compare simulations to first and second order
% shock = [
% 0% c1shockgyerr  
% 0% c1zcerr       
% 0% c1zierr       
% 0% c1yoerr       
% 0% c1muocerr     
% 0% c1mucerr      
% 0% c1omegacmerr  
% 0% c2shockgyerr  
% 0% c2zcerr       
% 0% c2zierr       
% 0% c2yoerr       
% -2% c2muocerr     
% 0% c2mucerr      
% 0% c2omegacmerr  
% 0% c1zwerr       
% 0% c1muowerr     
% 0% c2thetapvarerr
% 0% c1thetapvarerr
% 0% c2thetawvarerr
% 0% c1thetawvarerr
% 0% c1pitarerr    
% 0% c2pitarerr
% ];
%
%
% nperiods = 20;
% dset = 'f1';        
% makeirf
% 
% dset = 'f2';
% makeirfsecondorder
% 
% percent = 'Percent';
% ppt = 'Percentage Point';
% 
% titlelist = char('Gross Output','Consumption','Real Oil Price','Oil Demand');
% ylabels = char(percent, percent, percent, percent);
% legendlist = char('First order','Second order');
% figlabel = 'Foreign oil demand shock';
% 
% % makechart is a function that facilitates plotting.
% % it sits in the plot_support subdirectory.
% makechart(titlelist,legendlist,figlabel,ylabels,...
%           100*[f1_c1y_irf, f1_c1c_irf, f1_c1rpwopd_irf, f1_c1ow_irf],...
%           100*[f2_c1y_irf, f2_c1c_irf,...
%                f2_c1rpwopd_irf, f2_c1ow_irf])

